//*-*-Skylec Shader-*-*

#version 120
#include "/include/lib.h"
uniform sampler2D gcolor;
uniform sampler2D texture;
uniform int moonPhase;
uniform int isEyeInWater;
uniform float rainStrength;
uniform vec3 fogColor;
uniform vec3 skyColor;
varying vec3 sunPos;
varying vec2 texcoord;
const float sunPathRotation=25.0;//[0.0 25.0 50.0 75.0 90.0]

void main(){
#ifdef ORIGINAL_TONEMAP
vec3 diffuse=texture2D(gcolor,texcoord+mix(vec2(0.),vec2(snoise(texcoord*16+16.*4.+frameTimeCounter)*.002),saturate(float(isEyeInWater)))).rgb;
diffuse*=mix(vec3(1.),vec3(.7,.7,1.3),saturate(float(isEyeInWater)));
diffuse*=mix(vec3(1.),vec3(3.8,.7,.0),saturate(float(isEyeInWater-1)));
#else
vec3 diffuse=texture2D(gcolor,texcoord).rgb;
#endif
int a = ABOUT_ME;
float day=saturate(skyColor.r*2.);
float sunset=saturate((fogColor.r-.1)-fogColor.b);

#ifdef ORIGINAL_TONEMAP
vec3 worldColor=dayColor*mix(vec3(1.),vec3(.6,.7,1.),rainStrength);
diffuse.rgb=mix(mix(diffuse.rgb,toneMap(diffuse.rgb,worldColor),day),diffuse.rgb,sunset);
#endif

gl_FragData[0]=vec4(diffuse,1.);
}