//*-*-Skylec Shader-*-*

#version 120
#include "/include/lib.h"
uniform sampler2D texture;
uniform float far;
uniform vec3 fogColor;
uniform vec3 skyColor;

varying vec2 texcoord;
varying vec3 cPos;
varying vec3 wPos;
varying vec4 glcolor;

void main(){
#ifdef VANILLA_CLOUDS
vec4 diffuse=texture2D(texture,texcoord)*glcolor;
#ifdef ORIGINAL_TONEMAP
diffuse.rgb=mix(toneMap(diffuse.rgb,nightColor),diffuse.rgb,saturate(skyColor.r*2.));
#endif
diffuse.rgb=mix(diffuse.rgb,fogColor,smoothstep(0.,far,length(wPos.xz)));
gl_FragData[0]=diffuse;
#else
discard;
#endif
}