//*-*-Skylec Shader-*-*

#version 120
#include "/include/lib.h"
uniform sampler2D lightmap;
uniform sampler2D texture;
uniform int isEyeInWater;
uniform float far;
uniform float rainStrength;
uniform vec3 fogColor;
uniform vec3 skyColor;

varying vec2 lmcoord;
varying vec2 texcoord;
varying vec4 glcolor;

void main() {
vec4 diffuse=texture2D(texture,texcoord)*glcolor;
#ifdef ORIGINAL_WATER
float lmy=1.;
if(isEyeInWater!=1)lmy=lmcoord.y;
diffuse*=texture2D(lightmap,vec2(lmcoord.x,lmy));
#else
diffuse*=texture2D(lightmap,lmcoord);
#endif

float indoor=smoothstep(.8,.9,lmcoord.y);
float cave=smoothstep(1.,.5,lmcoord.y);
float day=saturate(skyColor.r*2.);
float sunset=saturate((fogColor.r-.1)-fogColor.b);

#ifdef ORIGINAL_TONEMAP
diffuse.rgb=mix(mix(diffuse.rgb,toneMap(diffuse.rgb,nightColor),1.-cave),diffuse.rgb,day);
#endif

#ifdef LIGHT_COLOR
diffuse.rgb+=mix(lightColor*max(lmcoord.x-.5,0.),vec3(.0),(indoor*.5+day*1.5)*.5);
#endif

#ifdef DUSK
diffuse.rgb=mix(diffuse.rgb,mix(diffuse.rgb,mix(toneMap(diffuse.rgb,duskColor),diffuse.rgb,rainStrength),indoor),sunset);
#endif

gl_FragData[0]=diffuse;
}