//*-*-Skylec Shader-*-*

#version 120
#include "/include/lib.h"
uniform mat4 gbufferModelView;
uniform mat4 gbufferProjectionInverse;
uniform int isEyeInWater;
uniform float viewHeight;
uniform float viewWidth;
uniform float far;
uniform float rainStrength;
varying vec3 sunPos;
varying vec3 glnormal;
uniform vec3 fogColor;
uniform vec3 skyColor;
varying vec3 cPos;
varying vec3 wPos;
varying vec4 starData;

#define ORIGINAL_CLOUDS

float fogify(float x,float w){return w/(x*x+w);}
vec3 calcSkyColor(vec3 pos){
#ifdef ORIGINAL_CLOUDS
float day=saturate(skyColor.r*2.);
float sunset=saturate((fogColor.r-.1)-fogColor.b);
float cl=mix(mix(.48,.46,day),.0,rainStrength);
float ll=mix(1.,1.2,saturate((fogColor.r-.1)-fogColor.b));
float noise;noise+=saturate(mix(smoothstep(cl,.63,fbm(wPos.xz*.04,6)),0.,float(isEyeInWater)))*.6+smoothstep(cl,1.,fbm(wPos.xz*.045,4))*ll;
vec3 cc=mix(mix(mix(vec3(.13,.13,.16),vec3(1.),day),vec3(.16),rainStrength),vec3(1.4,.8,.8),sunset);
float ca=noise*mix(1.,0.,smoothstep(0.,far,length(wPos.xz)));vec3 cloudColor=cc;
vec3 final=mix(pow(skyColor,vec3(1.6)),cloudColor,ca);
#else
vec3 final=skyColor;
#endif
float upDot=dot(pos,gbufferModelView[1].xyz);return mix(final,pow(fogColor,vec3(1.5)),fogify(max(upDot,0.),.01));}
void main(){
float day=saturate(skyColor.r*2.);
vec3 diffuse;
if(starData.a>.5){diffuse=starData.rgb;}else{vec4 pos=vec4(gl_FragCoord.xy/vec2(viewWidth,viewHeight)*2.-1.,1.,1.);
pos=gbufferProjectionInverse*pos;diffuse=calcSkyColor(normalize(pos.xyz));}
float a=mix(0.,1.,-normalize(cross(dFdx(cPos),dFdy(cPos))).y);
diffuse=mix(diffuse,toneMap(diffuse,duskColor),saturate((fogColor.r-.1)-fogColor.b));
#ifdef ORIGINAL_TONEMAP
diffuse=mix(toneMap(diffuse,nightColor),diffuse,day);
#endif
gl_FragData[0]=vec4(diffuse,a);
}